package com.ema.admin.modules.system.controller;

import cn.dev33.satoken.secure.SaSecureUtil;
import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.mybatisflex.core.paginate.Page;
import com.ema.admin.modules.system.converter.SysUserConverter;
import com.ema.admin.modules.system.entity.SysRole;
import com.ema.admin.modules.system.entity.SysUser;
import com.ema.admin.modules.system.service.SysAuthService;
import com.ema.admin.modules.system.service.SysRoleService;
import com.ema.admin.modules.system.service.SysUserService;
import com.ema.admin.modules.system.vo.SysUserInfoVo;
import com.ema.admin.modules.system.vo.SysUserQueryVo;
import com.ema.admin.modules.system.vo.SysUserSaveVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 系统用户信息表 控制层。
 *
 * @author LIJIAN
 * @since 2026-03-23
 */
@RestController
@Api(tags = "系统用户信息表接口")
@RequestMapping("/sysUser")
public class SysUserController {

    @Autowired
    private SysUserService sysUserService;
    @Autowired
    private SysUserConverter sysUserConverter;
    @Autowired
    private SysAuthService sysAuthService;
    @Autowired
    private SysRoleService sysRoleService;

    /**
     * 添加系统用户信息表。
     *
     * @param saveVo 系统用户信息表
     * @return {@code true} 添加成功，{@code false} 添加失败
     */
    @PostMapping("save")
    @ApiOperation("保存系统用户信息表")
    public boolean save(@RequestBody @ApiParam("系统用户信息表") SysUserSaveVo saveVo) {
        saveVo.setPassword(SaSecureUtil.md5(saveVo.getPassword()));
        SysUser sysUser = sysUserConverter.toSysUser(saveVo);
        boolean save = sysUserService.save(sysUser);
        if(CollUtil.isNotEmpty(saveVo.getRoleIds())){
            sysUserService.assignRolesToUser(sysUser.getId(),saveVo.getRoleIds());
        }
        return save;
    }

    /**
     * 根据主键删除系统用户信息表。
     *
     * @param id 主键
     * @return {@code true} 删除成功，{@code false} 删除失败
     */
    @DeleteMapping("remove/{id}")
    @ApiOperation("根据主键系统用户信息表")
    public boolean remove(@PathVariable @ApiParam("系统用户信息表主键") String id) {
        return sysUserService.removeById(id);
    }

    /**
     * 根据主键更新系统用户信息表。
     *
     * @param sysUser 系统用户信息表
     * @return {@code true} 更新成功，{@code false} 更新失败
     */
    @PutMapping("update")
    @ApiOperation("根据主键更新系统用户信息表")
    public boolean update(@RequestBody @ApiParam("系统用户信息表主键") SysUserSaveVo sysUser) {
        if(StrUtil.isNotBlank(sysUser.getPassword())){
            sysUser.setPassword(SaSecureUtil.md5(sysUser.getPassword()));
        }
        if(CollUtil.isNotEmpty(sysUser.getRoleIds())){
            sysUserService.assignRolesToUser(sysUser.getId(),sysUser.getRoleIds());
        }
        return sysUserService.updateById(sysUserConverter.toSysUser(sysUser));
    }

    /**
     * 查询所有系统用户信息表。
     *
     * @return 所有数据
     */
    @GetMapping("list")
    @ApiOperation("查询所有系统用户信息表")
    public List<SysUser> list() {
        return sysUserService.list();
    }

    /**
     * 根据系统用户信息表主键获取详细信息。
     *
     * @param id 系统用户信息表主键
     * @return 系统用户信息表详情
     */
    @GetMapping("getInfo/{id}")
    @ApiOperation("根据主键获取系统用户信息表")
    public SysUserInfoVo getInfo(@PathVariable @ApiParam("系统用户信息表主键") String id) {
        SysUser sysUser = sysUserService.getById(id);
        List<SysRole> roleList = sysRoleService.getRoleByUserId(id);
        return sysUserConverter.toSysUserInfoVo(sysUser,roleList);
    }

    /**
     * 分页查询系统用户信息表（带条件）。
     *
     * @param queryVo 查询条件
     * @return 分页对象
     */
    @PostMapping("page")
    @ApiOperation("分页查询系统用户信息表（带条件）")
    public Page<SysUserInfoVo> page(@RequestBody @ApiParam("查询条件") SysUserQueryVo queryVo) {
        return sysUserService.page(queryVo);
    }

}
